%
% Politecnico di Milano
% Corso Informatica B - Prof. Loiacono
% Esercizi di: Alessandro A. Nacci, Riccardo Cattaneo
% Per contatti: rcattaneo@elet.polimi.it
% ------------------------------------
% Esercitazione 8
% ESERCIZIO 1
% ------------------------------------
%
%	FORZA QUATTRO
%

% Realizzare in MATLAB il gioco forza 4
%
% Il gioco prevede due avversari che giocano alternativamente ad inserire in una
% matrice posta verticalmente sul piano di gioco una pedina del proprio colore.
% Vince il giocatore che per primo allinea 4 pedine del proprio colore in orizzontale, 
% in verticale od in diagonale.
%
% Si chiede di scrivere 8 funzioni:
% 1) cambiaGiocatore: dato un numero che rappresenta il giocatore 1, restituire il
%    numero che rappresenta il giocatore 2 e viceversa
% 2) inserisciPedina: data una matrice parzialmente riempita, la funzione chiede
%    ripetutamente al giocatore corrente di inserire una pedina finchè il valore
%    che inserisce - la colonna - non é corretto, quindi restituisce la altezza 
%    del primo buco libero
% 3) richiediColonna: una funzione richiamata da inserisciPedina che richiede 
%    ripetutamente all utente di inserire un valore di colonna valido
% 4) verificaMatrice: verifica che una matrice contenga una quadrupla in 
%    orizzontale, verticale e diagonale. Scrivere una funzione per ognuno dei 
%    tre casi 
% 5) forzaQuattro: il "main" del gioco. Fa alternare i giocatori, verifica Loiacono
%    stato del gioco, dichiara chi ha vinto

clear

h = 7;
w = 7;

tavola = zeros(h,w);
pedina_corrente = 2;


while ( verificaMatrice(pedina_corrente, tavola) ~= 1)

	clc
	disp(tavola)

	pedina_corrente = cambiaGiocatore(pedina_corrente);

	colonna = richiediColonna(pedina_corrente, w);

	tavola = inserisciPedina(pedina_corrente, colonna, tavola);

end


